; I2CT|[gCu  Version 1.00
; File:        i2c.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/01 21:00


        #INCLUDE <p18f14k50.inc>

        EXTERN Temp1
        EXTERN ARG1
        GLOBAL i2c_start,i2c_stop,i2c_restart,i2c_read,i2c_last_read,i2c_write
        GLOBAL i2c_block_write,i2c_block_read

        CODE
i2c_start   ; i2cɃX^[go
        bcf     SSPCON1,WCOL    ;   Փ˃tONA
        bsf     SSPCON2,SEN     ;   X^[go
        btfsc   SSPCON1,WCOL
        bra     i2c_start       ;   Փ˂ȂȂ܂Ń[v
i2c_start_sen
        btfsc   SSPCON2,SEN
        bra     i2c_start_sen   ;   SENNA܂Ń[v
        return

i2c_restart   ; i2cɍăX^[go
        bcf     PIR1,SSPIF      ; 荞݃tONA
        bsf     SSPCON2,RSEN     ;   ăX^[go
i2c_restart_rsen
        btfsc   SSPCON2,RSEN
        bra     i2c_restart_rsen   ;   RSENNA܂Ń[v
        return

i2c_write   ; 1byteo
        bcf     PIR1,SSPIF      ; 荞݃tONA
        movwf   SSPBUF          ; ݃f[^Zbg
i2c_write_sen
        btfss   PIR1,SSPIF
        bra     i2c_write_sen   ; f[^MACKM\ԂɂȂ܂őҋ@

        movlw   0   ;   X[u̕ԐMꍇ
        btfss   SSPCON2,ACKSTAT ; X[uACKԂĂ邩`FbN
        movlw   0ffh
        return


i2c_block_write ; FSR1ɃAhX@[LOWX^ɑMoCgZbg
        movwf   Temp1   ;   MoCg
i2c_block_write_loop
        movf    POSTINC1,W
        rcall   i2c_write
        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     i2c_block_write_loop
        return

i2c_block_read  ; FSR1ɃAhX@[LOWX^ɎMoCgZbg
        movwf   Temp1   ;   MoCg
        decf    Temp1
i2c_block_read_loop
        rcall   i2c_read
        movwf   POSTINC1,W
        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     i2c_block_read_loop
        rcall   i2c_last_read
        movwf   POSTINC1,W
        return

i2c_stop    ;   i2cSTOPo
        bcf     PIR1,SSPIF      ; 荞݃tONA
        bsf     SSPCON2,PEN     ; Xgbvo
i2c_stop_sen
        btfsc   SSPCON2,PEN
        bra     i2c_stop_sen     ; o͂܂Ń[v
        bcf     PIR1,SSPIF      ; 荞݃tONA
        return


i2c_read    ;   1byte
        bcf     PIR1,SSPIF      ; 荞݃tONA
        bsf     SSPCON2,RCEN    ; M
i2c_read_sen
        btfsc   SSPCON2,RCEN
        bra     i2c_read_sen    ; SSPBUFɎMf[^Zbg܂Ń[v
        bcf     SSPCON2,ACKDT   ; ACKo
        bsf     SSPCON2,ACKEN   ; ACKENZbg
i2c_read_sen2
        btfsc   SSPCON2,ACKEN
        bra     i2c_read_sen2   ; ACK̑MI郋[v
        movf    SSPBUF,W
        return

i2c_last_read    ;   ŏI1byte
        bcf     PIR1,SSPIF      ; 荞݃tONA
        bsf     SSPCON2,RCEN    ; M
i2c_last_read_sen
        btfsc   SSPCON2,RCEN
        bra     i2c_last_read_sen   ; PICMԂɂȂ܂Ń[v
        bsf     SSPCON2,ACKDT   ; NACKo
        bsf     SSPCON2,ACKEN   ; ACKENZbg
i2c_last_read_sen2
        btfsc   SSPCON2,ACKEN
        bra     i2c_last_read_sen2   ; ACK̑MI郋[v
        movf    SSPBUF,W
        return

        END
