; RTC-8564Cu[  Version 1.00
; File:        rtc.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/01 21:00

        #DEFINE  RTC_ASM 1

        #INCLUDE <p18f14k50.inc>
        #INCLUDE "i2c.inc"
        #INCLUDE "rtc.inc"

        EXTERN  ARG1
        GLOBAL  rtc_start,rtc_stop,rtc_vl_chk
        CODE

rtc_start   ;   ̃JEgJn
        rcall   i2c_start   ;   X^[gRfBVo
        movlw   RTC8564_SADS
        rcall   i2c_write
        movlw   RTC_CTL1
        rcall   i2c_write
        movlw   b'00000000' ;  RTC̎vJEgJn
        rcall   i2c_write
        rcall   i2c_stop    ;   XgbvRfBVo
        return

rtc_stop   ;   ̃JEg~
        rcall   i2c_start   ;   X^[gRfBVo
        movlw   RTC8564_SADS
        rcall   i2c_write
        movlw   RTC_CTL1
        rcall   i2c_write
        movlw   b'00100000' ;  RTC̎vJEg~
        rcall   i2c_write
        rcall   i2c_stop    ;   XgbvRfBVo
        return

rtc_vl_chk      ;   dቺorbgǂݏo
        rcall   i2c_start   ;   X^[gRfBVo
        movlw   RTC8564_SADS
        rcall   i2c_write

        movlw   RTC_SEC
        rcall   i2c_write

        rcall   i2c_restart

        movlw   RTC8564_SADS+1  ; ǂݍ݃[h
        rcall   i2c_write

        rcall   i2c_last_read

        movwf   ARG1

        rcall   i2c_stop    ;   XgbvRfBVo
        return


        END
