; RTC-8564gptv  Version 1.00
; File:        rtc1a.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/01 21:00

        #INCLUDE <p18f14k50.inc>
        ; U(12MHz) NbN PLLL(*4)
        ; EHb`hbO^C} dvO݃[h
        CONFIG FOSC = HS,CPUDIV = NOCLKDIV,PLLEN=ON,WDTEN=OFF,LVP=OFF

        #INCLUDE "lcd.inc"
        #INCLUDE "stdlib.inc"
        #INCLUDE "i2c.inc"
        #INCLUDE "rtc.inc"

;   vOads̃AhXTLPTRWX^ɏ㏑

LDTBLPTR MACRO ads
        movlw   UPPER ads
        movwf   TBLPTRU
        movlw   HIGH ads
        movwf   TBLPTRH
        movlw   LOW ads
        movwf   TBLPTRL
        ENDM

bank0        UDATA   ; ϐ̒` oN0@ANZXoN
Tcount1     RES 1      ; wait
Tcount2     RES 1      ; wait
Tcount3     RES 1      ; wait
LCD_WRITE   RES 1      ; writef[^w
LCD_TEMP    RES 1
Temp1       RES 1      ; Tu[`p̕ϐ
ARG1        RES 1      ; Tu[`
ARGL        RES 1
ARGH        RES 1
BYTE2HEX_TEMP RES 1

DIV_A       RES 1 ; Z̔폜w@Tu[`R[㓚Ԃ
DIV_MOD     RES 1 ; Tu[`R[]肪Ԃ
DIV_B       RES 1 ; Z̏w
DIV_AL      RES 1
DIV_AH      RES 1
DIV_MODL    RES 1
DIV_MODH    RES 1
LCD_BUF     RES 32     ; 16*2̃obt@
RTC_SADS    RES 1 ; X[uAhX
RTC_ADS     RES 1 ; AhX
RTC_BUF     RES 16  ; WX^ǂݏp

        GLOBAL LCD_WRITE,LCD_TEMP,Temp1,Tcount1,Tcount2,Tcount3
        GLOBAL DIV_MOD,DIV_A,DIV_B,DIV_MODL,DIV_MODH,DIV_AL,DIV_AH,ARG1,ARGL,ARGH
        GLOBAL BYTE2HEX_TEMP

        CODE
        ORG 0
        goto   start    ;   Zbg

start
        clrf    ANSEL   ; RC3-RC0,RA4fW^̓obt@ɐݒ
        clrf    ANSELH  ; RB5-RB4,RC7-RC6fW^̓obt@ɐݒ
        clrf    SLRCON  ; PORTA,PORTB,PORTCX[[gWɐݒ
        clrf    TRISA   ; PORTASo͂ɐݒ
        movlw   0f0h
        movwf   TRISB   ; RB7-RB4͂ɐݒ
        clrf    TRISC   ; PORTCSo͂ɐݒ肷
        clrf    PORTC   ; PORTCS0ɂB

        movlw   b'00101000' ; SSPW[on,I2C}X^[[h
        movwf   SSPCON1
        clrf    SSPCON2     ;
        movlw   01dh
        movwf   SSPADD      ; 400kbps
        clrf    SSPSTAT
        bcf     RCON,IPEN   ; 荞ݗD揇ʂȂ
        bsf     IPR1,SSPIP  ; ʃx

        rcall   lcd_init    ;   t

;      vOf[^[֓]LCD

        LDTBLPTR lcd_init_str ; }NTBLPTRWX^lcd_init_strݒ

        movlw   d'32'
        movwf   Temp1

        lfsr    FSR0,LCD_BUF
lcd_init_str_set_loop
        tblrd   *+          ;   vOTBLPTRǂݏoTBLPTR+1
        movf    TABLAT,W
        movwf   POSTINC0    ;   ԐڃAhbVO@AhX̓ANZX+1
        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     lcd_init_str_set_loop
       
        rcall   rtc_vl_chk  ;   RTCobNAbvĂmF
        btfss   ARG1,7
        goto    loop        ;   RTC̓obNAbvĂ̂ŏȂ


rtc_init    ;   RTC
        LDTBLPTR rtc_init_tbl
        movlw   d'18'
        movwf   Temp1
        lfsr    FSR0,RTC_SADS
rtc_init_loop
        tblrd   *+          ;   vOTBLPTRǂݏoTBLPTR+1
        movf    TABLAT,W
        movwf   POSTINC0    ;   ԐڃAhbVO@AhX̓ANZX+1
        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     rtc_init_loop
rtc_mem_write
        rcall   i2c_start   ;   X^[gRfBVo
        lfsr    FSR1,RTC_SADS
        movlw   d'18'
        rcall   i2c_block_write
        rcall   i2c_stop    ;   XgbvRfBVo
        rcall   rtc_start

loop
        rcall   i2c_start   ;   X^[gRfBVo
        movlw   RTC8564_SADS
        rcall   i2c_write
        movlw   0
        rcall   i2c_write
        rcall   i2c_restart
        movlw   RTC8564_SADS+1  ; ǂݍ݃[h
        rcall   i2c_write

        lfsr    FSR1,RTC_BUF
        movlw   d'16'
        rcall   i2c_block_read
        rcall   i2c_stop    ;   XgbvRfBVo

        movf    RTC_BUF+RTC_YEAR,W,BANKED   ; Nǂ݂
        movwf   ARG1
        lfsr    FSR1,LCD_BUF+d'2'
        rcall   byte2hex

        movf    RTC_BUF+RTC_MONTH,W,BANKED   ; ǂ݂
        andlw   b'00011111' ; ʃrbg}XN
        movwf   ARG1
        lfsr    FSR1,LCD_BUF+d'5'
        rcall   byte2hex

        movf    RTC_BUF+RTC_DAY,W,BANKED   ; ǂ݂
        andlw   b'00111111' ; ʃrbg}XN
        movwf   ARG1
        lfsr    FSR1,LCD_BUF+d'8'
        rcall   byte2hex

        movf    RTC_BUF+RTC_HOUR,W,BANKED   ; ǂ݂
        andlw   b'00111111' ; ʃrbg}XN
        movwf   ARG1
        lfsr    FSR1,LCD_BUF+d'16'
        rcall   byte2hex

        movf    RTC_BUF+RTC_MIN,W ,BANKED  ; ǂ݂
@      andlw   b'01111111' ; ŏʃrbg}XN
        movwf   ARG1
        lfsr    FSR1,LCD_BUF+d'19'
        rcall   byte2hex

        movf    RTC_BUF+RTC_SEC,W,BANKED  ; bǂ݂
        andlw   b'01111111' ; ŏʃrbg}XN
        movwf   ARG1
        lfsr    FSR1,LCD_BUF+d'22'
        rcall   byte2hex

        lfsr    FSR1,LCD_BUF
        rcall   lcd_disp

        rcall   wait500
        rcall   wait500

        goto    loop


rtc_init_tbl        ; RTC̏萔
        DB      RTC8564_SADS,  0 ;X[uAhX,AhX
        DB      b'00100000', b'00000000' ; CTL1,CTL2
        DB      h'34', h'26'       ; 02h b,
        DB      h'23' ,h'15'       ; 04h ,
        DB      d'04' ,h'08'       ; 06h j,
        DB      h'13' , h'80'       ; 08h N,A[ 
        DB      h'80' , h'80'       ; 0ah A[ ,A[  
        DB      h'80' ,h'00'       ; 0ch A[ j,CLOCKOUT g
        DB      h'00' , h'00'       ; 0eh ^C}[CTL,^C}[

lcd_init_str
;                0123456789abcdef
        DB      "2012/09/23      "
        DB      "23:45:56        "

wait500                 ; 0.5bWait
        movlw   d'50'  ; 10ms*50=0.5s
        movwf   Tcount1
dloop1
        movlw   d'200'	; 50s*200=10ms
        movwf   Tcount2
dloop2                   ; t=(12+12*count3)/48MHz 50s
        movlw   d'199'
        movwf   Tcount3
        nop
dloop3
        decfsz  Tcount3
        goto    dloop3
        decfsz  Tcount2
        goto    dloop2
        decfsz  Tcount1
        goto    dloop1
        return

        END
